#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vector>

using namespace std;

struct Etendus
{
    char nadalapaev;
    char *kuupaev;
    char *kellaaeg;
    char *lavastus;
    char *koht;
};

vector<Etendus> kava;

struct Lavastus
{
         char *nimetus;
         int mituKorda;
         vector<char*> kuupaevad;
};
vector<Lavastus> v;

void lisaLavastus(char *p, char *kp)
{
    for(int k=0;k<v.size();k++)
    {
        if(strcmp(p,v[k].nimetus)==0)
        {
            v[k].mituKorda++;
            v[k].kuupaevad.push_back(kp);
            return;
        }
    }
    Lavastus uus;
    uus.nimetus=p;
    uus.mituKorda=1;
    uus.kuupaevad.push_back(kp);
    v.push_back(uus);
}

FILE *tulemus;

void bubbleSort()
{
  int i, j, temp;

  for (i = (v.size() - 1); i > 0; i--)
  {
    for (j = 1; j <= i; j++)
    {
      if (v[j-1].mituKorda < v[j].mituKorda)
      {
        Lavastus temp = v[j-1];
        v[j-1] = v[j];
        v[j] = temp;
      }
    }
  }
}

bool readFile(char nimi[])
{
    FILE *in = fopen(nimi,"rt");
    if(!in)
       return false;

    printf("\n\tETENDUSTE KAVA\n");
    fprintf(tulemus,"\n\tETENDUSTE KAVA\n");
    while(!feof(in))
    {
        char line[100];
        fgets(line,100,in);
        printf("%s",line);
        Etendus uus;
        char *p = strtok(line,"\t");
        uus.nadalapaev = line[0];

        p = strtok(NULL,"\t");
        uus.kuupaev = new char[strlen(p)+1];
        strcpy(uus.kuupaev,p);

        p = strtok(NULL,"\t");
        uus.kellaaeg = new char[strlen(p)+1];
        strcpy(uus.kellaaeg,p);

        p = strtok(NULL,"\t");
        uus.lavastus = new char[strlen(p)+1];
        strcpy(uus.lavastus,p);

        p = strtok(NULL,"\n");
        uus.koht = new char[strlen(p)+1];
        strcpy(uus.koht,p);

        kava.push_back(uus);
        printf("%c  %10s  kell %5s - %-28s (%s)\n",uus.nadalapaev,uus.kuupaev,
                  uus.kellaaeg,uus.lavastus,uus.koht);
        fprintf(tulemus,"%c  %10s  kell %5s - %-28s (%s)\n",uus.nadalapaev,uus.kuupaev,
                  uus.kellaaeg,uus.lavastus,uus.koht);
    }
    fclose(in);
    return true;
}
void mituEtendustIgalPaeval()
{
     printf("\n\n\tMitu etendust antud peval\n");
     fprintf(tulemus,"\n\n\tMitu etendust antud peval\n");

     char kp[20] = "";
     int etendusi = 0;
     for(int k=0;k<kava.size();k++)
     {
         if(strcmp(kava[k].kuupaev,kp)!=0)
         {
             if(etendusi>0)
             {
                 printf("%s - %d etendust\n",kp,etendusi);
                 fprintf(tulemus,"%s - %d etendust\n",kp,etendusi);
             }

            strcpy(kp,kava[k].kuupaev);
            etendusi = 1;
         }
         else
            etendusi++;
     }
     printf("%s - %d etendust\n",kp,etendusi);
     fprintf(tulemus,"%s - %d etendust\n",kp,etendusi);
}

void mituKordaIgaLavastust()
{
    printf("\n\n\tLavastuste etenduste arv\n");
    fprintf(tulemus,"\n\n\tLavastuste etenduste arv\n");
    for(int i=0;i<kava.size();i++)
        lisaLavastus(kava[i].lavastus,kava[i].kuupaev);

    bubbleSort();

    for(int k=0;k<v.size();k++)
    {
        printf("%-28s - %d korda\n",v[k].nimetus,v[k].mituKorda);
        fprintf(tulemus,"%-28s - %d korda\n",v[k].nimetus,v[k].mituKorda);

        vector<char*> kp = v[k].kuupaevad;
        printf("\t%s",kp[0]);
        fprintf(tulemus,"\t%s",kp[0]);
        for(int j=1;j<kp.size();j++)
        {
            printf(", %s",kp[j]);
            fprintf(tulemus,", %s",kp[j]);
        }
        printf("\n");
        fprintf(tulemus,"\n");
    }

}

int main()
{
    tulemus = fopen("Tulemus.txt","wt");

    if(!readFile("..\\Teater.txt"))
    {
       printf("Faili ei saa avada!\n");
       return 1;
    }

    mituEtendustIgalPaeval();
    mituKordaIgaLavastust();

    fclose(tulemus);
    return 0;
}

